/*********************************************************************
63 dB step attenuator using two ebay 31.5 dB modules in series with their
control lines wired i  parallel
*********************************************************************/

#include "rotary.h"

// used by rotary encoder
int encoder = 0;                   // flag and value from rotary encoder
int button = 0;                    // flag and value from  encoder button

Rotary r = Rotary(3, 2);            // polling instead of interrupt so use 6&7 instead of 2&3

// define pins used to contoll step attenuator mdules
#define DB_32  12
#define DB_16  11
#define DB_8   10
#define DB_4    9
#define DB_2    8
#define DB_1    7

int AttenValue = 0;                   // attenuation value
int AttenStep  = 1;                   // step size  1 or 10 dB

//rfswitch selector
const int D4 = 4;     // band button
const int D13 = 5;     // RF switch high/low
int rfswitch_PushCounter = 0;    
int rfswitch_State = 0;          
int last_rfswitch_State = 0; 

void setup()   
{
  Serial.begin(115200);// Main menu variables and definitions
  Serial.println("ok");
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);
  sei();

  // init done
  // set control pins for attenuator modules
  pinMode(DB_32 , OUTPUT);
  pinMode(DB_16 , OUTPUT);
  pinMode(DB_8 , OUTPUT);
  pinMode(DB_4 , OUTPUT);
  pinMode(DB_2 , OUTPUT);
  pinMode(DB_1 , OUTPUT);
  pinMode(2 , INPUT_PULLUP);
  pinMode(3 , INPUT_PULLUP);

  pinMode(D4 , INPUT_PULLUP);
  pinMode(D13 , OUTPUT);
  
  delay(500);
}

void loop()
{
  // chkEncoder();
  // delay(20);
  rfswitch();
  if (encoder)
  {
    if (   encoder < 0)    AttenValue -= AttenStep  ;      // because of mounting position invert selection
    if (   encoder > 0)    AttenValue += AttenStep  ;      // because of mounting position invert selection
    if ( AttenValue < 0 )  AttenValue = 0;
    if (AttenValue > 63 ) {  // limit max atten
      if (AttenStep == 1)
        AttenValue = 63;
      else AttenValue = 60;
    }
    setAtten();
    encoder = 0;
  }

  delay(50);
}

// interrupt service routine for encoder
ISR(PCINT2_vect) {
  unsigned char result = r.process();
  if (result) {
    if (result == DIR_CW) {
      encoder--;
    }
    else {
      encoder++;
    }
  }
}

void setAtten() {
  int atten = AttenValue;
   Serial.println(AttenValue);
  if (atten >= 32) {             // test each bit value to see if it needs to be set
    digitalWrite(DB_32, HIGH);
    atten = atten - 32;          // if set reduce value for nrxt test
  }
  else  digitalWrite(DB_32, LOW);
  if (atten >= 16) {
    digitalWrite(DB_16, HIGH);
    atten = atten - 16;
  }
  else  digitalWrite(DB_16, LOW);
  if (atten >= 8) {
    digitalWrite(DB_8, HIGH);
    atten = atten - 8;
  }
  else  digitalWrite(DB_8, LOW);
  if (atten >= 4) {
    digitalWrite(DB_4, HIGH);
    atten = atten - 4;
  }
  else  digitalWrite(DB_4, LOW);
  if (atten >= 2) {
    digitalWrite(DB_2, HIGH);
    atten = atten - 2;
  }
  else  digitalWrite(DB_2, LOW);
  if (atten >= 1) digitalWrite(DB_1, HIGH);
  else  digitalWrite(DB_1, LOW);
}
